import os
import sys
import math as m

master_folder = os.getcwd()

sys.path.append(os.path.join(master_folder, "Tello-master"))
sys.path.append(os.path.join(master_folder, "marvelmind.py-master\src"))

from marvelmind import MarvelmindHedge
import tello as tl

my_increments = 1  # Increments decide how many meters it should go before checking new pos. Maximum increments are 5 meters

old_angle = 0
z_height = 0
old_orientation = ''

final_angle = 0


def get_current_coordinates(hedge):
    hedge.dataEvent.wait()  # Wait for new data
    hedge.dataEvent.clear()
    return hedge.position()[1], hedge.position()[2], #x y
    print('im at: x', hedge.position()[1],'y', hedge.position()[2])

def calculate_angle(my_pos, wanted_pos):
    x1, y1 = my_pos
    x2, y2 = wanted_pos

    dx = x2 - x1
    dy = y2 - y1
    
    angle = m.atan2(dy, dx)
    #print(angle, 'angle radiants')
    angle_deg = round(m.degrees(angle), 2)                             #Radians to degrees

    rotation = ''
    #print (angle_deg, 'original angle')

    o_angle = 90 - angle_deg                                 #rotate angle 90 deg ccw 
    #print (o_angle, 'angle-90')
    if 180 > o_angle > 0:
        rotation = 'CW'
        #print(o_angle, 'new angle')

    if o_angle > 180:
        o_angle = 360 - o_angle
        rotation = 'CCW'
        #print (o_angle, 'new angle')

    if o_angle < 0:
        o_angle = (abs(o_angle))
        rotation = 'CCW'
        
    return round((o_angle),2), rotation
    

def calculate_distance(my_pos, wanted_pos):
    x1, y1 = my_pos
    x2, y2 = wanted_pos

    dx = x2 - x1
    dy = y2 - y1

    distance = round(m.sqrt(dx**2 + dy**2), 2)
    return distance
    

def rotate_towards_angle(angle, orientation):
    if angle > 0:
        if orientation == 'CCW':
            tl.anticlockwise(angle)

        else:
            tl.clockwise(angle)

    else:
        print('angle = 0, straigt ahead')

def second_angle(new_angle, old_angle, orientation, last_orientation):
    if orientation == 'CW' and last_orientation =='CW':
        if new_angle < old_angle:
            angle = round(abs(new_angle - old_angle),2)
            print('1new_angle -old_angle')
            orientation = 'CCW'
        else:
            angle = round(abs(new_angle - old_angle),2)
            print('12new_angle -old_angle')
            orientation ='CW'

    elif orientation == 'CCW' and last_orientation =='CW':
        angle = round(abs(new_angle - old_angle),2)
        print('2new_angle - old_angle')
        orientation = 'CW'

    elif orientation == 'CCW' and last_orientation == 'CCW':
        if new_angle < old_angle:
            angle = round(abs(new_angle - old_angle),2)
            print('21new_angle -old_angle')
            orientation = 'CCW'
        else:
            angle = round(abs(new_angle - old_angle),2)
            print('22new_angle -old_angle')
            orientation ='CCW'

    elif orientation == 'CW' and last_orientation =='CCW':
        angle = round(abs(new_angle - old_angle),2)
        print('3new_angle - old_angle')
        orientation = 'CW'

    return angle, orientation

def move_towards_coordinate(distance):
    if distance > 0.75:                  #if further than 50cm, just go 50 cm
        tl.forward(75)
        print('going forward 75cm')
    else:
        tl.forward(distance*100)        #if shorter, go complete distance


def read_z():
    zpos = tl.get_tof()/1000
    return zpos


def find_z(my_pos, wanted_pos):
    z1 = wanted_pos
    z2 = my_pos

    z_diff = round(- (z2 - z1),2) #get two decimals
    return z_diff
    
def Tello_Commands_Z(elevation):
    if elevation > 0.2: #positive value, upwards
        tl.up(elevation*100)

    elif elevation < -0.2: #negative value, downwards 
        tl.down(abs(elevation)*100)

    elif 0.2 > elevation > -0.2:
        print('staying level')

def calc_totangle(totangle, rotangle, orientation):
    if orientation == 'CCW':
        totangle = totangle - rotangle
    else:
        totangle = totangle + rotangle 
    return totangle
    
def main():
    tl.start()
    print(tl.get_battery(), 'percentage of battery left')

    hedge = MarvelmindHedge(tty="COM8", adr=None, debug=False)  # Create MarvelmindHedge object

    if len(sys.argv) > 1:
        hedge.tty = sys.argv[1]

    hedge.start()  # Start receiving data from Marvelmind

    tl.takeoff()

    final_angle = 0
    
    try:
        while True:
            user_input = input("Please enter new coordinates (x y z): ")
            numbers = list(map(float, user_input.split()))
            if len(numbers) != 3:
                print('Error: Invalid input format')
                continue
            
            target_pos = numbers
            target_pos_xy = (target_pos[0], target_pos[1])
            target_x, target_y, target_z = numbers
            print('Selected Coordinates: x =', target_pos[0], 'y =', target_pos[1])

            while True:
                current_pos = get_current_coordinates(hedge)
                print("Current pos: x =", current_pos[0], "y =", current_pos[1],)
                current_pos_z = read_z()
                print('z = ', current_pos_z)

                angle, orientation = calculate_angle(current_pos, target_pos_xy)
                print('a:', angle, 'o:', orientation)
                
                distance = calculate_distance(current_pos, target_pos_xy)
                print('d=', distance)
                
                z_diff = find_z(current_pos_z, target_pos[2])
                
                rotate_towards_angle(angle, orientation)  
                move_towards_coordinate(distance)
                Tello_Commands_Z(z_diff)

                print('done commands')
                final_angle = calc_totangle(final_angle, angle, orientation)
                print(final_angle, 'final angle')
                old_angle = angle
                old_orientation = orientation

                while True:
                    current_pos = get_current_coordinates(hedge)
                    print('current pos:', current_pos)
                    current_pos_z = read_z()
                    print('z = ', current_pos_z)

                    angle, orientation = calculate_angle(current_pos, target_pos_xy)
                    distance = calculate_distance(current_pos, target_pos_xy)
                    print('a:', angle, 'o:', orientation)
                    z_diff = find_z(current_pos_z, target_pos[2])

                    rotangle, orientation = second_angle(angle, old_angle, orientation, old_orientation)
                    rotate_towards_angle(rotangle, orientation)
                    Tello_Commands_Z(z_diff) 
                    
                    
                    print(angle, 'relative angle')
                    print(rotangle, 'differation_angle', orientation)
                    print(distance, 'distance')
                    final_angle = calc_totangle(final_angle, rotangle, orientation)
                    print('finalangle:', final_angle)

                    if distance > 0.2:
                        move_towards_coordinate(distance)

                        print('done commands2')
                        old_angle = angle
                        old_orientation = orientation
                        print(old_angle, old_orientation, 'OA and OO')

                    if distance < 0.2:
                        print('Reached the target coordinates')
                        print(final_angle, 'rotating back to north')
                        if final_angle < 0:
                            tl.clockwise(abs(final_angle))
                        else:
                            tl.anticlockwise(abs(final_angle))
                        break
                    print('Distance to target:', distance)
                    
                break

    except KeyboardInterrupt:
        hedge.stop()  # Stop receiving data

if __name__ == "__main__":
    main()
